From 30df5667d5652738b339b9553cdd2809982edf3f Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Fri, 26 Jun 2015 08:52:12 +0300
Subject: [PATCH] Fix minor typos

---
 src/man/sssd.conf.5.xml                       | 4 ++--
 src/providers/ad/ad_gpo_child.c               | 2 +-
 src/providers/ldap/sdap_async_initgroups_ad.c | 2 +-
 src/sss_client/common.c                       | 2 +-
 src/sss_client/libwbclient/wbc_sid_common.c   | 2 +-
 src/tests/sysdb-tests.c                       | 6 +++---
 6 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/src/man/sssd.conf.5.xml b/src/man/sssd.conf.5.xml
index 75d13a6..0a1a3bb 100644
--- a/src/man/sssd.conf.5.xml
+++ b/src/man/sssd.conf.5.xml
@@ -756,7 +756,7 @@ fallback_homedir = /home/%u
                             Some of the additional NSS responder requests can
                             return more attributes than just the POSIX ones
                             defined by the NSS interface. The list of attributes
-                            is controlled by this option. It is handle the same
+                            is controlled by this option. It is handled the same
                             way as the <quote>user_attributes</quote> option of
                             the InfoPipe responder (see
                             <citerefentry>
@@ -1430,7 +1430,7 @@ pam_account_expired_message = Account expired, please call help desk.
                         <para>
                             If 2-Factor-Authentication (2FA) is used and
                             credentials should be saved this value determines
-                            the minimal lenght the first authentication factor
+                            the minimal length the first authentication factor
                             (long term password) must have to be saved as SHA512
                             hash into the cache.
                         </para>
diff --git a/src/providers/ad/ad_gpo_child.c b/src/providers/ad/ad_gpo_child.c
index 4750732..03951af 100644
--- a/src/providers/ad/ad_gpo_child.c
+++ b/src/providers/ad/ad_gpo_child.c
@@ -585,7 +585,7 @@ copy_smb_file_to_gpo_cache(SMBCCTX *smbc_ctx,
  * than the cached_gpt_version, thereby triggering a fresh download.
  *
  * Note that the backend will later do the following:
- * - backend will save the the sysvol_gpt_version to sysdb cache
+ * - backend will save the sysvol_gpt_version to sysdb cache
  * - backend will read the policy file from the GPO_CACHE
  */
 static errno_t
diff --git a/src/providers/ldap/sdap_async_initgroups_ad.c b/src/providers/ldap/sdap_async_initgroups_ad.c
index 463d850..e210db9 100644
--- a/src/providers/ldap/sdap_async_initgroups_ad.c
+++ b/src/providers/ldap/sdap_async_initgroups_ad.c
@@ -1445,7 +1445,7 @@ sdap_ad_tokengroups_initgroups_send(TALLOC_CTX *mem_ctx,
     state->use_id_mapping = use_id_mapping;
     state->domain = domain;
 
-    /* We can compute the the gidNumber attribute from SIDs obtained from
+    /* We can compute the gidNumber attribute from SIDs obtained from
      * the tokenGroups lookup in case ID mapping is used for a user from the
      * parent domain. For trusted domains, we need to know the group type
      * to be able to filter out domain-local groups. Additionally, as a
diff --git a/src/sss_client/common.c b/src/sss_client/common.c
index 383572b..9be9dc7 100644
--- a/src/sss_client/common.c
+++ b/src/sss_client/common.c
@@ -198,7 +198,7 @@ static enum sss_status sss_cli_recv_rep(enum sss_cli_command cmd,
     int len;
     int ret;
 
-    header[0] = SSS_NSS_HEADER_SIZE; /* unitl we know the real lenght */
+    header[0] = SSS_NSS_HEADER_SIZE; /* unitl we know the real length */
     header[1] = 0;
     header[2] = 0;
     header[3] = 0;
diff --git a/src/sss_client/libwbclient/wbc_sid_common.c b/src/sss_client/libwbclient/wbc_sid_common.c
index 60ddbdd..d562d77 100644
--- a/src/sss_client/libwbclient/wbc_sid_common.c
+++ b/src/sss_client/libwbclient/wbc_sid_common.c
@@ -148,7 +148,7 @@ wbcErr wbcStringToSid(const char *str,
     sid->id_auth[1] = (x & 0x00ff00000000ULL) >> 32;
     sid->id_auth[0] = (x & 0xff0000000000ULL) >> 40;
 
-    /* now read the the subauthorities */
+    /* now read the subauthorities */
     p = q +1;
     sid->num_auths = 0;
     while (sid->num_auths < WBC_MAXSUBAUTHS) {
diff --git a/src/tests/sysdb-tests.c b/src/tests/sysdb-tests.c
index 522a44a..24d1527 100644
--- a/src/tests/sysdb-tests.c
+++ b/src/tests/sysdb-tests.c
@@ -1835,7 +1835,7 @@ START_TEST (test_sysdb_cache_password_ex)
 
     val = ldb_msg_find_attr_as_int(res->msgs[0], SYSDB_CACHEDPWD_TYPE, 0);
     fail_unless(val == SSS_AUTHTOK_TYPE_PASSWORD,
-                "Unexptected authtok type, found [%d], expected [%d].",
+                "Unexpected authtok type, found [%d], expected [%d].",
                 val, SSS_AUTHTOK_TYPE_PASSWORD);
 
     ret = sysdb_cache_password_ex(test_ctx->domain, data->username,
@@ -1849,12 +1849,12 @@ START_TEST (test_sysdb_cache_password_ex)
 
     val = ldb_msg_find_attr_as_int(res->msgs[0], SYSDB_CACHEDPWD_TYPE, 0);
     fail_unless(val == SSS_AUTHTOK_TYPE_2FA,
-                "Unexptected authtok type, found [%d], expected [%d].",
+                "Unexpected authtok type, found [%d], expected [%d].",
                 val, SSS_AUTHTOK_TYPE_2FA);
 
     val = ldb_msg_find_attr_as_int(res->msgs[0], SYSDB_CACHEDPWD_FA2_LEN, 0);
     fail_unless(val == 12,
-                "Unexptected second factor lenght, found [%d], expected [%d].",
+                "Unexpected second factor length, found [%d], expected [%d].",
                 val, 12);
 
     talloc_free(test_ctx);
-- 
2.3.2